<?php
/**
 * @package Nextpaw Webchat Widget plugin
 */
namespace Includes;

final class InitWebchat
{
    /**
     * store all clasess
     * @return array full list of classes
     */
    public static function get_services(){
        require_once( NEXTPAW_WEBCHAT__PLUGIN_DIR . 'Includes/pages/Admin.php' );
        require_once( NEXTPAW_WEBCHAT__PLUGIN_DIR . 'Includes/base/Enqueue.php' );
        return [
            Pages\Admin::class,
            Base\Enqueue::class
        ];
    }

    /**
     * Loop through classes and intialize and call regsiter if it exist
     */
    public static function register_services(){
        foreach (self::get_services() as $class){
            $service = self::instantiate($class);
            if(method_exists($service, 'register')){
                $service->register();
            }
        }
    }

    /**
     * Intialize classes
     * @param $class
     * @return mixed
     */
    private static function instantiate($class){
        return new $class;
    }
}