<?php
/**
 * @package Nextpaw Webchat Widget plugin
 */
namespace Includes\Pages;

use \Includes\Base\BaseController;

require_once( NEXTPAW_WEBCHAT__PLUGIN_DIR . 'Includes/base/BaseController.php' );
class Admin extends BaseController
{
	private $nextpawWebchat_setting_options;
    public function register(){
            add_action( 'admin_menu', array($this, 'nextpawWebchat_add_settings_page') );
            add_action( 'admin_init', array($this, 'webchat_setting_page_init') );
            add_filter("plugin_action_links_$this->plugin", array($this, 'setting_link'));
            if ( ! is_admin() ) {
                add_action( 'wp_head', array($this,'insert_webchat_script') );
            }
    }

    public static function insert_webchat_script(){
        $webchatStatus = get_option('nextpaw_webchat_status');
        $webchatAppId = get_option('nextpaw_app_id');
        if($webchatStatus == 'enable') {
            $data = array(
                'app_id' => $webchatAppId
            );
            include NEXTPAW_WEBCHAT__PLUGIN_DIR . '/templates/webchat_code.php';
        }
    }

    public function nextpawWebchat_add_settings_page() {
        add_options_page( 'NextPaw Webchat Widget plugin page', 'Nextpaw Webchat Widget', 'manage_options', 'nextpaw-webchat-plugin', array($this, 'nextpaw_admin_settings_page') );
    }

    public function nextpaw_admin_settings_page()
    {
        require_once $this->plugin_path. '/templates/admin.php';
    }

	public function webchat_setting_page_init()
    {
        register_setting('nextpawWebchat_plugin_options_group', 'nextpaw_webchat_status');
        register_setting('nextpawWebchat_plugin_options_group', 'nextpaw_app_id');
    }

	public function nextpawWebchat_setting_sanitize($input) {
		$sanitary_values = array();
		if ( isset( $input['nextpawWebchat_0'] ) ) {
			$sanitary_values['nextpawWebchat_0'] = $input['nextpawWebchat_0'];
		}

		return $sanitary_values;
	}

    public function nextpawWebchat_plugin_options_validate( $input ) {
        $newinput['api_key'] = trim( $input['api_key'] );
        if ( ! preg_match( '/^[a-z0-9]{32}$/i', $newinput['api_key'] ) ) {
            $newinput['api_key'] = '';
        }
        return $newinput;
    }

    public function setting_link($links){
        $setting_link = '<a href="options-general.php?page=nextpaw-webchat-plugin">Settings</a>';
        array_push($links,$setting_link);
        return $links;
    }
}